const SQLModel = require("./sql");
const db = require("../database");

class Staff extends SQLModel {
    constructor() {
        super("staffs");
    }
    async findOneLeftJoinUser(staff_id) {
        const query = `
            SELECT users.id,users.phone_number,staffs.*  
            FROM \`${this.tableName}\`
            LEFT JOIN users 
            ON users.id = staffs.user_id
            WHERE staffs.id = ?
        `;
        const [result] = await db.mysql.query(query, [staff_id]);
        if (!result || result.length == 0) return null;
        return result[0];
    }
    async findAllLeftJoinUser() {
        const query = `
            SELECT users.id,users.phone_number,staffs.*  
            FROM \`${this.tableName}\`
            LEFT JOIN users 
            ON users.id = staffs.user_id
            WHERE 1
        `;
        const [result] = await db.mysql.query(query);
        if (!result || result.length == 0) return null;
        return result;
    }
    async searchLeftJoin(value, orderBy = null) {
        let query = `
            SELECT users.id, users.phone_number, staffs.* 
            FROM \`${this.tableName}\`
            LEFT JOIN users 
            ON users.id = staffs.user_id 
            WHERE staffs.name LIKE ? OR users.phone_number LIKE ?
        `;
        
        if (orderBy) {
            query += ` ORDER BY ${orderBy}`;
        }
        
        const [result] = await db.mysql.query(query, [`%${value}%`,`%${value}%`]);
        if (!result || result.length == 0) return null;
        return result;
    }
};

module.exports = Staff;