const SQLModel = require("./sql")
const db = require("../database");

class Table extends SQLModel {
    constructor() {
        super("tables");
    }
    async findAllJoinTypesUsers() {
        let query = `SELECT tt.id AS type_id, tt.*, tb.*, u.phone_number FROM ${this.tableName} AS tb JOIN table_types AS tt ON tb.table_type = tt.id LEFT JOIN users AS u ON tb.user_id = u.id WHERE 1;`;
    
        const [result] = await db.mysql.query(query);
        if (!result || result.length == 0) return null;
        return result;
    }
    async findOneJoinTypesUsersByID(id) {
        let query = `SELECT tt.id AS type_id, tb.*, u.phone_number FROM ${this.tableName} AS tb JOIN table_types AS tt ON tb.table_type = tt.id LEFT JOIN users AS u ON tb.user_id = u.id WHERE tb.id = ?`;
    
        const [result] = await db.mysql.query(query,[id]);
        if (!result || result.length == 0) return null;
        return result[0];
    }
    async searchJoinTypes(value, orderBy = null) {
        let query = `SELECT tt.id AS type_id,tt.*,tb.* FROM ${this.tableName} AS tb JOIN table_types AS tt ON tb.table_type = tt.id WHERE tb.table_number LIKE ? OR tb.table_type LIKE ? OR tt.description LIKE ?`;
        
        if (orderBy) {
            query += ` ORDER BY ${orderBy}`;
        }
        
        const [result] = await db.mysql.query(query, [`%${value}%`,`%${value}%`,`%${value}%`]);
        if (!result || result.length == 0) return null;
        return result;
    }
};

module.exports = Table;